import processing.serial.*;
import processing.net.*;
Server myServer;
Client c;
int val = 0;

Serial myPort;
int data[] = {0,0,0};
int linefeed = 10;

void setup() {
  size(255, 255);
  // Starts a myServer on port 5204
  myServer = new Server(this, 5204); 
  myPort = new Serial(this, Serial.list()[0], 9600);
}

void draw() {
  c = myServer.available();
  if(c != null){
     val = c.read();
     background(val);
     myServer.write(val);
     myPort.write(val);
  }
  if (checkForNewData()) {
    background(data[1]/4);
    myServer.write(data[1]/4);
  }
}

void mouseMoved(){
  val = mouseY;
  background(val);
  myServer.write(val);
  myPort.write(val);
}

boolean checkForNewData() {
  if (myPort.available() > 0) { 
    String inString = myPort.readStringUntil(linefeed);
    if (inString != null) {
      print(inString);
      data = int(split(trim(inString), ',')); 
      return true;
    }
  }
  return false;
}